Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManage.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManage.cpp	(revision 16852)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManage.cpp	(revision 16853)
@@ -1353,5 +1353,5 @@
                 /* first assume it's a UUID */
                 Guid uuid(a->argv[2]);
-                ComPtr<IDVDImage2> dvdImage;
+                ComPtr<IDVDImage> dvdImage;
                 rc = a->virtualBox->GetDVDImage(uuid, dvdImage.asOutParam());
                 if (FAILED(rc) || !dvdImage)
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageDisk.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageDisk.cpp	(revision 16852)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageDisk.cpp	(revision 16853)
@@ -909,5 +909,5 @@
     else if (strcmp(a->argv[0], "dvd") == 0)
     {
-        ComPtr<IDVDImage2> dvdImage;
+        ComPtr<IDVDImage> dvdImage;
         CHECK_ERROR(a->virtualBox, OpenDVDImage(filepath, Guid(), dvdImage.asOutParam()));
     }
@@ -950,5 +950,5 @@
     if (strcmp(a->argv[0], "dvd") == 0)
     {
-        ComPtr<IDVDImage2> dvdImage;
+        ComPtr<IDVDImage> dvdImage;
         rc = a->virtualBox->GetDVDImage(uuid, dvdImage.asOutParam());
         /* not a UUID or not registered? Then it must be a filename */
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageInfo.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageInfo.cpp	(revision 16852)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageInfo.cpp	(revision 16853)
@@ -572,5 +572,5 @@
     if (SUCCEEDED(rc) && dvdDrive)
     {
-        ComPtr<IDVDImage2> dvdImage;
+        ComPtr<IDVDImage> dvdImage;
         rc = dvdDrive->GetImage(dvdImage.asOutParam());
         if (SUCCEEDED(rc) && dvdImage)
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageList.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageList.cpp	(revision 16852)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageList.cpp	(revision 16853)
@@ -431,9 +431,9 @@
     if (strcmp(a->argv[0], "dvds") == 0)
     {
-        com::SafeIfaceArray<IDVDImage2> dvds;
+        com::SafeIfaceArray<IDVDImage> dvds;
         CHECK_ERROR(a->virtualBox, COMGETTER(DVDImages)(ComSafeArrayAsOutParam(dvds)));
         for (size_t i = 0; i < dvds.size(); ++ i)
         {
-            ComPtr<IDVDImage2> dvdImage = dvds[i];
+            ComPtr<IDVDImage> dvdImage = dvds[i];
             Guid uuid;
             dvdImage->COMGETTER(Id)(uuid.asOutParam());
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp	(revision 16852)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp	(revision 16853)
@@ -1119,5 +1119,5 @@
                 /* first assume it's a UUID */
                 Guid uuid(dvd);
-                ComPtr<IDVDImage2> dvdImage;
+                ComPtr<IDVDImage> dvdImage;
                 rc = a->virtualBox->GetDVDImage(uuid, dvdImage.asOutParam());
                 if (FAILED(rc) || !dvdImage)
Index: trunk/src/VBox/Frontends/VBoxSDL/VBoxSDL.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxSDL/VBoxSDL.cpp	(revision 16852)
+++ trunk/src/VBox/Frontends/VBoxSDL/VBoxSDL.cpp	(revision 16853)
@@ -1787,5 +1787,5 @@
         {
             /* try to find an existing one */
-            ComPtr <IDVDImage2> image;
+            ComPtr <IDVDImage> image;
             rc = virtualBox->FindDVDImage (medium, image.asOutParam());
             if (FAILED (rc))
Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxGlobal.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxGlobal.h	(revision 16852)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxGlobal.h	(revision 16853)
@@ -147,5 +147,5 @@
 
     const CHardDisk2 &hardDisk() const { return mHardDisk; }
-    const CDVDImage2 &dvdImage() const { return mDVDImage; }
+    const CDVDImage &dvdImage() const { return mDVDImage; }
     const CFloppyImage2 &floppyImage() const { return mFloppyImage; }
 
@@ -247,5 +247,5 @@
 
     CHardDisk2 mHardDisk;
-    CDVDImage2 mDVDImage;
+    CDVDImage mDVDImage;
     CFloppyImage2 mFloppyImage;
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleWnd.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleWnd.cpp	(revision 16852)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleWnd.cpp	(revision 16853)
@@ -2916,6 +2916,6 @@
                             .arg (vbox.GetVersion().remove ("_OSE"));
 
-    CDVDImage2Vector vec = vbox.GetDVDImages();
-    for (CDVDImage2Vector::ConstIterator it = vec.begin();
+    CDVDImageVector vec = vbox.GetDVDImages();
+    for (CDVDImageVector::ConstIterator it = vec.begin();
          it != vec.end(); ++ it)
     {
@@ -2949,5 +2949,5 @@
     QUuid uuid;
 
-    CDVDImage2 image = vbox.FindDVDImage (aSource);
+    CDVDImage image = vbox.FindDVDImage (aSource);
     if (image.isNull())
     {
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp	(revision 16852)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp	(revision 16853)
@@ -2293,5 +2293,5 @@
             case KDriveState_ImageMounted:
             {
-                CDVDImage2 img = dvd.GetImage();
+                CDVDImage img = dvd.GetImage();
                 item = QString (sSectionItemTpl2)
                     .arg (tr ("Image", "details report (DVD)"),
@@ -3002,6 +3002,6 @@
         VBoxMediaList::iterator first = mMediaList.end();
 
-        CDVDImage2Vector vec = mVBox.GetDVDImages();
-        for (CDVDImage2Vector::ConstIterator it = vec.begin();
+        CDVDImageVector vec = mVBox.GetDVDImages();
+        for (CDVDImageVector::ConstIterator it = vec.begin();
              it != vec.end(); ++ it)
         {
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxMediaManagerDlg.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxMediaManagerDlg.cpp	(revision 16852)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxMediaManagerDlg.cpp	(revision 16853)
@@ -1127,5 +1127,5 @@
         case VBoxDefs::MediaType_DVD:
         {
-            CDVDImage2 image = item->medium().dvdImage();
+            CDVDImage image = item->medium().dvdImage();
             image.Close();
             result = image;
@@ -1554,5 +1554,5 @@
         case VBoxDefs::MediaType_DVD:
         {
-            CDVDImage2 image = mVBox.OpenDVDImage (aLocation, uuid);
+            CDVDImage image = mVBox.OpenDVDImage (aLocation, uuid);
             if (mVBox.isOk())
             {
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsCD.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsCD.cpp	(revision 16852)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsCD.cpp	(revision 16853)
@@ -109,5 +109,5 @@
         case KDriveState_ImageMounted:
         {
-            CDVDImage2 img = dvd.GetImage();
+            CDVDImage img = dvd.GetImage();
             QString src = img.GetLocation();
             AssertMsg (!src.isNull(), ("Image file must not be null"));
Index: trunk/src/VBox/Main/ApplianceImpl.cpp
===================================================================
--- trunk/src/VBox/Main/ApplianceImpl.cpp	(revision 16852)
+++ trunk/src/VBox/Main/ApplianceImpl.cpp	(revision 16853)
@@ -238,5 +238,4 @@
     appliance.createObject();
     rc = appliance->init(this);
-//     ComAssertComRCThrowRC(rc);
 
     if (SUCCEEDED(rc))
Index: trunk/src/VBox/Main/ConsoleImpl.cpp
===================================================================
--- trunk/src/VBox/Main/ConsoleImpl.cpp	(revision 16852)
+++ trunk/src/VBox/Main/ConsoleImpl.cpp	(revision 16853)
@@ -2551,5 +2551,5 @@
         case DriveState_ImageMounted:
         {
-            ComPtr <IDVDImage2> ImagePtr;
+            ComPtr <IDVDImage> ImagePtr;
             rc = mDVDDrive->GetImage (ImagePtr.asOutParam());
             if (SUCCEEDED (rc))
@@ -4410,5 +4410,5 @@
         if (driveState == DriveState_ImageMounted)
         {
-            ComPtr <IDVDImage2> image;
+            ComPtr <IDVDImage> image;
             rc = drive->GetImage (image.asOutParam());
             CheckComRCReturnRC (rc);
Index: trunk/src/VBox/Main/ConsoleImpl2.cpp
===================================================================
--- trunk/src/VBox/Main/ConsoleImpl2.cpp	(revision 16852)
+++ trunk/src/VBox/Main/ConsoleImpl2.cpp	(revision 16853)
@@ -1071,5 +1071,5 @@
             rc = CFGMR3InsertInteger(pCfg,  "Mountable",            1);             RC_CHECK();
 
-            ComPtr<IDVDImage2> dvdImage;
+            ComPtr<IDVDImage> dvdImage;
             hrc = dvdDrive->GetImage(dvdImage.asOutParam());                        H();
             if (dvdImage)
Index: trunk/src/VBox/Main/DVDDriveImpl.cpp
===================================================================
--- trunk/src/VBox/Main/DVDDriveImpl.cpp	(revision 16852)
+++ trunk/src/VBox/Main/DVDDriveImpl.cpp	(revision 16853)
@@ -266,7 +266,7 @@
      * We also don't lock mParent since its mParent field is const. */
 
-    ComObjPtr <DVDImage2> image;
-    rc = mParent->virtualBox()->findDVDImage2 (&imageId, NULL,
-                                               true /* aSetError */, &image);
+    ComObjPtr<DVDImage> image;
+    rc = mParent->virtualBox()->findDVDImage(&imageId, NULL,
+                                             true /* aSetError */, &image);
 
     if (SUCCEEDED (rc))
@@ -370,5 +370,5 @@
 }
 
-STDMETHODIMP DVDDrive::GetImage (IDVDImage2 **aDVDImage)
+STDMETHODIMP DVDDrive::GetImage (IDVDImage **aDVDImage)
 {
     CheckComArgOutPointerValid(aDVDImage);
Index: trunk/src/VBox/Main/MediumImpl.cpp
===================================================================
--- trunk/src/VBox/Main/MediumImpl.cpp	(revision 16852)
+++ trunk/src/VBox/Main/MediumImpl.cpp	(revision 16853)
@@ -1096,8 +1096,8 @@
 
 ////////////////////////////////////////////////////////////////////////////////
-// DVDImage2 class
-////////////////////////////////////////////////////////////////////////////////
-
-DEFINE_EMPTY_CTOR_DTOR (DVDImage2)
+// DVDImage class
+////////////////////////////////////////////////////////////////////////////////
+
+DEFINE_EMPTY_CTOR_DTOR (DVDImage)
 
 /**
@@ -1105,5 +1105,5 @@
  *       mVirtualBox write lock.
  */
-HRESULT DVDImage2::unregisterWithVirtualBox()
+HRESULT DVDImage::unregisterWithVirtualBox()
 {
     return mVirtualBox->unregisterDVDImage (this);
Index: trunk/src/VBox/Main/VirtualBoxImpl.cpp
===================================================================
--- trunk/src/VBox/Main/VirtualBoxImpl.cpp	(revision 16852)
+++ trunk/src/VBox/Main/VirtualBoxImpl.cpp	(revision 16853)
@@ -643,5 +643,5 @@
 
 STDMETHODIMP
-VirtualBox::COMGETTER(DVDImages) (ComSafeArrayOut (IDVDImage2 *, aDVDImages))
+VirtualBox::COMGETTER(DVDImages) (ComSafeArrayOut (IDVDImage *, aDVDImages))
 {
     if (ComSafeArrayOutIsNull (aDVDImages))
@@ -653,5 +653,5 @@
     AutoReadLock alock (this);
 
-    SafeIfaceArray <IDVDImage2> images (mData.mDVDImages2);
+    SafeIfaceArray <IDVDImage> images (mData.mDVDImages2);
     images.detachTo (ComSafeArrayOutArg (aDVDImages));
 
@@ -1166,5 +1166,5 @@
 /** @note Doesn't lock anything. */
 STDMETHODIMP VirtualBox::OpenDVDImage (IN_BSTR aLocation, IN_GUID aId,
-                                       IDVDImage2 **aDVDImage)
+                                       IDVDImage **aDVDImage)
 {
     CheckComArgStrNotEmptyOrNull(aLocation);
@@ -1181,5 +1181,5 @@
         id.create();
 
-    ComObjPtr <DVDImage2> image;
+    ComObjPtr <DVDImage> image;
     image.createObject();
     rc = image->init (this, aLocation, id);
@@ -1196,5 +1196,5 @@
 
 /** @note Locks objects! */
-STDMETHODIMP VirtualBox::GetDVDImage (IN_GUID aId, IDVDImage2 **aDVDImage)
+STDMETHODIMP VirtualBox::GetDVDImage (IN_GUID aId, IDVDImage **aDVDImage)
 {
     CheckComArgOutSafeArrayPointerValid(aDVDImage);
@@ -1204,6 +1204,6 @@
 
     Guid id = aId;
-    ComObjPtr <DVDImage2> image;
-    HRESULT rc = findDVDImage2 (&id, NULL, true /* setError */, &image);
+    ComObjPtr <DVDImage> image;
+    HRESULT rc = findDVDImage (&id, NULL, true /* setError */, &image);
 
     /* the below will set *aDVDImage to NULL if image is null */
@@ -1214,5 +1214,5 @@
 
 /** @note Locks objects! */
-STDMETHODIMP VirtualBox::FindDVDImage (IN_BSTR aLocation, IDVDImage2 **aDVDImage)
+STDMETHODIMP VirtualBox::FindDVDImage (IN_BSTR aLocation, IDVDImage **aDVDImage)
 {
     CheckComArgNotNull(aLocation);
@@ -1222,6 +1222,6 @@
     CheckComRCReturnRC (autoCaller.rc());
 
-    ComObjPtr <DVDImage2> image;
-    HRESULT rc = findDVDImage2 (NULL, aLocation, true /* setError */, &image);
+    ComObjPtr <DVDImage> image;
+    HRESULT rc = findDVDImage (NULL, aLocation, true /* setError */, &image);
 
     /* the below will set *aDVDImage to NULL if dvd is null */
@@ -2696,5 +2696,5 @@
 
 /**
- * Searches for a DVDImage2 object with the given ID or location in the list of
+ * Searches for a DVDImage object with the given ID or location in the list of
  * registered DVD images. If both ID and file path are specified, the first
  * object that matches either of them (not necessarily both) is returned.
@@ -2710,7 +2710,7 @@
  * @note Locks this object and image objects for reading.
  */
-HRESULT VirtualBox::findDVDImage2 (const Guid *aId, CBSTR aLocation,
-                                   bool aSetError,
-                                   ComObjPtr <DVDImage2> *aImage /* = NULL */)
+HRESULT VirtualBox::findDVDImage(const Guid *aId, CBSTR aLocation,
+                                 bool aSetError,
+                                 ComObjPtr<DVDImage> *aImage /* = NULL */)
 {
     AssertReturn (aId || aLocation, E_INVALIDARG);
@@ -2731,5 +2731,5 @@
     bool found = false;
 
-    for (DVDImage2List::const_iterator it = mData.mDVDImages2.begin();
+    for (DVDImageList::const_iterator it = mData.mDVDImages2.begin();
          it != mData.mDVDImages2.end();
          ++ it)
@@ -2939,6 +2939,6 @@
 
     {
-        ComObjPtr <DVDImage2> image;
-        rc = findDVDImage2 (&aId, aLocation, false /* aSetError */, &image);
+        ComObjPtr<DVDImage> image;
+        rc = findDVDImage (&aId, aLocation, false /* aSetError */, &image);
         if (SUCCEEDED (rc))
         {
@@ -3069,5 +3069,5 @@
                 case 1: /* DVDImages */
                 {
-                    ComObjPtr <DVDImage2> image;
+                    ComObjPtr<DVDImage> image;
                     image.createObject();
                     rc = image->init (this, *it);
@@ -3182,5 +3182,5 @@
                 Key imagesNode = registryNode.createKey ("DVDImages");
 
-                for (DVDImage2List::const_iterator it =
+                for (DVDImageList::const_iterator it =
                         mData.mDVDImages2.begin();
                      it != mData.mDVDImages2.end();
@@ -3423,5 +3423,5 @@
  * @note Locks this object for writing and @a aImage for reading.
  */
-HRESULT VirtualBox::registerDVDImage (DVDImage2 *aImage,
+HRESULT VirtualBox::registerDVDImage (DVDImage *aImage,
                                       bool aSaveRegistry /*= true*/)
 {
@@ -3480,5 +3480,5 @@
  * @note Locks this object for writing and @a aImage for reading.
  */
-HRESULT VirtualBox::unregisterDVDImage (DVDImage2 *aImage,
+HRESULT VirtualBox::unregisterDVDImage (DVDImage *aImage,
                                         bool aSaveRegistry /*= true*/)
 {
@@ -3667,5 +3667,5 @@
 
     /* check DVD paths */
-    for (DVDImage2List::iterator it = mData.mDVDImages2.begin();
+    for (DVDImageList::iterator it = mData.mDVDImages2.begin();
          it != mData.mDVDImages2.end();
          ++ it)
Index: trunk/src/VBox/Main/idl/VirtualBox.xidl
===================================================================
--- trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 16852)
+++ trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 16853)
@@ -1395,5 +1395,5 @@
     </attribute>
 
-    <attribute name="DVDImages" type="IDVDImage2" readonly="yes" safearray="yes">
+    <attribute name="DVDImages" type="IDVDImage" readonly="yes" safearray="yes">
       <desc>
         Array of CD/DVD image objects registered with this VirtualBox instance.
@@ -1940,5 +1940,5 @@
         </desc>
       </param>
-      <param name="image" type="IDVDImage2" dir="return">
+      <param name="image" type="IDVDImage" dir="return">
         <desc>Opened CD/DVD image object.</desc>
       </param>
@@ -1961,5 +1961,5 @@
         <desc>UUID of the image to look for.</desc>
       </param>
-      <param name="image" type="IDVDImage2" dir="return">
+      <param name="image" type="IDVDImage" dir="return">
         <desc>Found CD/DVD image object.</desc>
       </param>
@@ -1996,5 +1996,5 @@
         <desc>CD/DVD image file path to look for.</desc>
       </param>
-      <param name="image" type="IDVDImage2" dir="return">
+      <param name="image" type="IDVDImage" dir="return">
         <desc>Found CD/DVD image object.</desc>
       </param>
@@ -7723,5 +7723,5 @@
       <ul>
         <li>IHardDisk2 (virtual hard disks)</li>
-        <li>IDVDImage2 (standard CD/DVD ISO image files)</li>
+        <li>IDVDImage (standard CD/DVD ISO image files)</li>
         <li>IFloppyImage2 (raw floppy image files)</li>
       </ul>
@@ -7852,5 +7852,5 @@
         For example, states <link to="MediaState_NotCreated"/>,
         <link to="MediaState_LockedWrite"/>, <link to="MediaState_Creating"/>,
-        <link to="MediaState_Deleting"/> are meaningless for IDVDImage2 and
+        <link to="MediaState_Deleting"/> are meaningless for IDVDImage and
         IFloppyImage2 media.
       </desc>
@@ -9277,16 +9277,18 @@
 
   <!--
-  // IDVDImage2
+  // IDVDImage
   /////////////////////////////////////////////////////////////////////////
   -->
 
   <interface
-    name="IDVDImage2" extends="IMedium"
-    uuid="1c5165f1-9543-478d-a117-84a1d2317068"
+    name="IDVDImage" extends="IMedium"
+    uuid="b1f90bbb-e8a9-4484-9af1-3638e943f763"
     wsmap="managed"
   >
     <desc>
-      The IDVDImage2 interface represents a medium containing the image
+      The IDVDImage interface represents a medium containing the image
       of a CD or DVD disk in the ISO format.
+
+      This is a subclass of <link to="IMedium" />; see remarks there.
     </desc>
 
@@ -9351,5 +9353,5 @@
     <method name="getImage">
       <desc>Returns the currently mounted CD/DVD image.</desc>
-      <param name="image" type="IDVDImage2" dir="return"/>
+      <param name="image" type="IDVDImage" dir="return"/>
     </method>
 
Index: trunk/src/VBox/Main/include/DVDDriveImpl.h
===================================================================
--- trunk/src/VBox/Main/include/DVDDriveImpl.h	(revision 16852)
+++ trunk/src/VBox/Main/include/DVDDriveImpl.h	(revision 16853)
@@ -55,5 +55,5 @@
         }
 
-        ComObjPtr <DVDImage2> image;
+        ComObjPtr<DVDImage> image;
         ComPtr <IHostDVDDrive> hostDrive;
         DriveState_T state;
@@ -94,5 +94,5 @@
     STDMETHOD(CaptureHostDrive) (IHostDVDDrive *aHostDVDDrive);
     STDMETHOD(Unmount)();
-    STDMETHOD(GetImage) (IDVDImage2 **aDVDImage);
+    STDMETHOD(GetImage)(IDVDImage **aDVDImage);
     STDMETHOD(GetHostDrive) (IHostDVDDrive **aHostDVDDrive);
 
Index: trunk/src/VBox/Main/include/MediumImpl.h
===================================================================
--- trunk/src/VBox/Main/include/MediumImpl.h	(revision 16852)
+++ trunk/src/VBox/Main/include/MediumImpl.h	(revision 16853)
@@ -236,10 +236,10 @@
 
 /**
- * The DVDImage2 component class implements the IDVDImage2 interface.
- */
-class ATL_NO_VTABLE DVDImage2
-    : public com::SupportErrorInfoDerived <ImageMediumBase, DVDImage2, IDVDImage2>
-    , public VirtualBoxSupportTranslation <DVDImage2>
-    , public IDVDImage2
+ * The DVDImage component class implements the IDVDImage interface.
+ */
+class ATL_NO_VTABLE DVDImage
+    : public com::SupportErrorInfoDerived<ImageMediumBase, DVDImage, IDVDImage>
+    , public VirtualBoxSupportTranslation<DVDImage>
+    , public IDVDImage
 {
 public:
@@ -247,19 +247,19 @@
     COM_FORWARD_IMedium_TO_BASE (ImageMediumBase)
 
-    VIRTUALBOXSUPPORTTRANSLATION_OVERRIDE (DVDImage2)
-
-    DECLARE_NOT_AGGREGATABLE (DVDImage2)
+    VIRTUALBOXSUPPORTTRANSLATION_OVERRIDE (DVDImage)
+
+    DECLARE_NOT_AGGREGATABLE (DVDImage)
 
     DECLARE_PROTECT_FINAL_CONSTRUCT()
 
-    BEGIN_COM_MAP (DVDImage2)
+    BEGIN_COM_MAP (DVDImage)
         COM_INTERFACE_ENTRY (ISupportErrorInfo)
         COM_INTERFACE_ENTRY2 (IMedium, ImageMediumBase)
-        COM_INTERFACE_ENTRY (IDVDImage2)
+        COM_INTERFACE_ENTRY (IDVDImage)
     END_COM_MAP()
 
     NS_DECL_ISUPPORTS
 
-    DECLARE_EMPTY_CTOR_DTOR (DVDImage2)
+    DECLARE_EMPTY_CTOR_DTOR (DVDImage)
 
     // public initializer/uninitializer for internal purposes only
@@ -279,5 +279,5 @@
 
     /** For com::SupportErrorInfoImpl. */
-    static const char *ComponentName() { return "DVDImage2"; }
+    static const char *ComponentName() { return "DVDImage"; }
 
 private:
Index: trunk/src/VBox/Main/include/VirtualBoxImpl.h
===================================================================
--- trunk/src/VBox/Main/include/VirtualBoxImpl.h	(revision 16852)
+++ trunk/src/VBox/Main/include/VirtualBoxImpl.h	(revision 16853)
@@ -44,5 +44,5 @@
 class SessionMachine;
 class HardDisk2;
-class DVDImage2;
+class DVDImage;
 class FloppyImage2;
 class MachineCollection;
@@ -127,5 +127,5 @@
     STDMETHOD(COMGETTER(Machines2)) (ComSafeArrayOut (IMachine *, aMachines));
     STDMETHOD(COMGETTER(HardDisks2)) (ComSafeArrayOut (IHardDisk2 *, aHardDisks));
-    STDMETHOD(COMGETTER(DVDImages)) (ComSafeArrayOut (IDVDImage2 *, aDVDImages));
+    STDMETHOD(COMGETTER(DVDImages)) (ComSafeArrayOut (IDVDImage *, aDVDImages));
     STDMETHOD(COMGETTER(FloppyImages)) (ComSafeArrayOut (IFloppyImage2 *, aFloppyImages));
     STDMETHOD(COMGETTER(ProgressOperations)) (ComSafeArrayOut (IProgress *, aOperations));
@@ -154,7 +154,7 @@
 
     STDMETHOD(OpenDVDImage) (IN_BSTR aLocation, IN_GUID aId,
-                             IDVDImage2 **aDVDImage);
-    STDMETHOD(GetDVDImage) (IN_GUID aId, IDVDImage2 **aDVDImage);
-    STDMETHOD(FindDVDImage) (IN_BSTR aLocation, IDVDImage2 **aDVDImage);
+                             IDVDImage **aDVDImage);
+    STDMETHOD(GetDVDImage) (IN_GUID aId, IDVDImage **aDVDImage);
+    STDMETHOD(FindDVDImage) (IN_BSTR aLocation, IDVDImage **aDVDImage);
 
     STDMETHOD(OpenFloppyImage) (IN_BSTR aLocation, IN_GUID aId,
@@ -236,6 +236,6 @@
     HRESULT findHardDisk2 (const Guid *aId, CBSTR aLocation,
                            bool aSetError, ComObjPtr <HardDisk2> *aHardDisk = NULL);
-    HRESULT findDVDImage2 (const Guid *aId, CBSTR aLocation,
-                           bool aSetError, ComObjPtr <DVDImage2> *aImage = NULL);
+    HRESULT findDVDImage(const Guid *aId, CBSTR aLocation,
+                         bool aSetError, ComObjPtr<DVDImage> *aImage = NULL);
     HRESULT findFloppyImage2 (const Guid *aId, CBSTR aLocation,
                               bool aSetError, ComObjPtr <FloppyImage2> *aImage = NULL);
@@ -259,6 +259,6 @@
     HRESULT unregisterHardDisk2 (HardDisk2 *aHardDisk, bool aSaveRegistry = true);
 
-    HRESULT registerDVDImage (DVDImage2 *aImage, bool aSaveRegistry = true);
-    HRESULT unregisterDVDImage (DVDImage2 *aImage, bool aSaveRegistry = true);
+    HRESULT registerDVDImage(DVDImage *aImage, bool aSaveRegistry = true);
+    HRESULT unregisterDVDImage(DVDImage *aImage, bool aSaveRegistry = true);
 
     HRESULT registerFloppyImage (FloppyImage2 *aImage, bool aSaveRegistry = true);
@@ -362,5 +362,5 @@
 
     typedef std::list <ComObjPtr <HardDisk2> > HardDisk2List;
-    typedef std::list <ComObjPtr <DVDImage2> > DVDImage2List;
+    typedef std::list <ComObjPtr <DVDImage> > DVDImageList;
     typedef std::list <ComObjPtr <FloppyImage2> > FloppyImage2List;
     typedef std::list <ComObjPtr <SharedFolder> > SharedFolderList;
@@ -429,5 +429,5 @@
 
         HardDisk2List mHardDisks2;
-        DVDImage2List mDVDImages2;
+        DVDImageList mDVDImages2;
         FloppyImage2List mFloppyImages2;
         SharedFolderList mSharedFolders;
Index: trunk/src/VBox/Main/testcase/tstAPI.cpp
===================================================================
--- trunk/src/VBox/Main/testcase/tstAPI.cpp	(revision 16852)
+++ trunk/src/VBox/Main/testcase/tstAPI.cpp	(revision 16853)
@@ -961,5 +961,5 @@
         }
         {
-            com::SafeIfaceArray <IDVDImage2> images;
+            com::SafeIfaceArray <IDVDImage> images;
             CHECK_ERROR_BREAK (virtualBox,
                                COMGETTER(DVDImages) (ComSafeArrayAsOutParam (images)));
Index: trunk/src/VBox/Main/testcase/tstVBoxAPILinux.cpp
===================================================================
--- trunk/src/VBox/Main/testcase/tstVBoxAPILinux.cpp	(revision 16852)
+++ trunk/src/VBox/Main/testcase/tstVBoxAPILinux.cpp	(revision 16853)
@@ -364,5 +364,5 @@
      */
     nsID uuid = {0};
-    nsCOMPtr<IDVDImage2> dvdImage;
+    nsCOMPtr<IDVDImage> dvdImage;
 
     rc = virtualBox->OpenDVDImage(NS_LITERAL_STRING("/home/achimha/isoimages/winnt4ger.iso").get(),
Index: trunk/src/VBox/Main/xpcom/server.cpp
===================================================================
--- trunk/src/VBox/Main/xpcom/server.cpp	(revision 16852)
+++ trunk/src/VBox/Main/xpcom/server.cpp	(revision 16853)
@@ -143,8 +143,8 @@
 NS_IMPL_THREADSAFE_ISUPPORTS1_CI(Snapshot, ISnapshot)
 
-NS_DECL_CLASSINFO(DVDImage2)
-NS_IMPL_THREADSAFE_ISUPPORTS2_AMBIGUOUS_CI(DVDImage2,
+NS_DECL_CLASSINFO(DVDImage)
+NS_IMPL_THREADSAFE_ISUPPORTS2_AMBIGUOUS_CI(DVDImage,
                                            IMedium, ImageMediumBase,
-                                           IDVDImage2, DVDImage2)
+                                           IDVDImage, DVDImage)
 NS_DECL_CLASSINFO(FloppyImage2)
 NS_IMPL_THREADSAFE_ISUPPORTS2_AMBIGUOUS_CI(FloppyImage2,